; 

      .486                      ; create 32 bit code
      .model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive

      include onanlist.inc        ; local includes for this file

      ListBox PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

  .data?
    hList dd ?

  .code

start:

; 

    ; ------------------
    ; set global values
    ; ------------------
      mov hInstance,   rv(GetModuleHandleW, NULL)
      mov CommandLine, rv(GetCommandLineW)
      mov hIcon,       rv(LoadIconW,hInstance,500)
      mov hCursor,     rv(LoadCursorW,NULL,IDC_ARROW)
      mov sWid,        rv(GetSystemMetrics,SM_CXSCREEN)
      mov sHgt,        rv(GetSystemMetrics,SM_CYSCREEN)

      call Main

      invoke ExitProcess,eax

; 

Main proc

    LOCAL Wwd:DWORD,Wht:DWORD,Wtx:DWORD,Wty:DWORD

    LOCAL pClassName    :DWORD
    LOCAL ClassBuff[64] :WORD

    LOCAL pDisplay  :DWORD
    LOCAL displaybuff[64]:WORD

    mov pClassName, ptr$(ClassBuff)
    mov pDisplay,   ptr$(displaybuff)

    invoke LoadStringW,hInstance,20,pClassName,64
    invoke LoadStringW,hInstance,30,pDisplay,64

  ; --------------------------------------------
  ; register class name for CreateWindowEx call
  ; --------------------------------------------
    invoke RegisterWinClass,ADDR WndProc,pClassName,
                       hIcon,hCursor,COLOR_BTNFACE+1

    mov Wwd, 600
    mov Wht, 400
    invoke TopXY,Wwd,sWid
    mov Wtx, eax
    invoke TopXY,Wht,sHgt
    mov Wty, eax

    invoke CreateWindowExW,WS_EX_LEFT,
                           pClassName,
                           pDisplay,
                           WS_OVERLAPPEDWINDOW,
                           Wtx,Wty,Wwd,Wht,
                           NULL,NULL,
                           hInstance,NULL
    mov hWnd,eax

    push esi
    mov esi, 1
  @@:
    invoke LoadStringW,hInstance,esi,pClassName,64
    fn SendMessageW,hList,LB_ADDSTRING,0,pClassName
    add esi, 1
    cmp esi, 10
    jle @B
    pop esi

    invoke ShowWindow,hWnd, SW_SHOWNORMAL
    invoke UpdateWindow,hWnd

    call MsgLoop
    ret

Main endp

; 

RegisterWinClass proc lpWndProc:DWORD, lpClassName:DWORD,
                      Icon:DWORD, Cursor:DWORD, bColor:DWORD

    LOCAL wc:WNDCLASSEX

    mov wc.cbSize,         sizeof WNDCLASSEX
    mov wc.style,          CS_BYTEALIGNCLIENT or \
                           CS_BYTEALIGNWINDOW
    m2m wc.lpfnWndProc,    lpWndProc
    mov wc.cbClsExtra,     NULL
    mov wc.cbWndExtra,     NULL
    m2m wc.hInstance,      hInstance
    m2m wc.hbrBackground,  bColor
    mov wc.lpszMenuName,   NULL
    m2m wc.lpszClassName,  lpClassName
    m2m wc.hIcon,          Icon
    m2m wc.hCursor,        Cursor
    m2m wc.hIconSm,        Icon

    invoke RegisterClassExW, ADDR wc

    ret

RegisterWinClass endp

; 

MsgLoop proc

    LOCAL msg:MSG

    push esi
    push edi
    xor edi, edi                        ; clear EDI
    lea esi, msg                        ; Structure address in ESI
    jmp jumpin

    StartLoop:
      invoke TranslateMessage, esi
    ; --------------------------------------
    ; perform any required key processing here
    ; --------------------------------------
      invoke DispatchMessageW,  esi
    jumpin:
      invoke GetMessageW,esi,edi,edi,edi
      test eax, eax
      jnz StartLoop

    mov eax, msg.wParam
    pop edi
    pop esi

    ret

MsgLoop endp

; 

WndProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    LOCAL var    :DWORD
    LOCAL caW    :DWORD
    LOCAL caH    :DWORD
    LOCAL Rct    :RECT
    LOCAL buffer1[260]:BYTE  ; these are two spare buffers
    LOCAL buffer2[260]:BYTE  ; for text manipulation etc..

    Switch uMsg
      Case WM_COMMAND

      Case WM_CREATE
        invoke ListBox,10,10,300,300,hWin,600
        mov hList, eax

      Case WM_SYSCOLORCHANGE

      Case WM_SIZE

      Case WM_CLOSE

      Case WM_DESTROY
        invoke PostQuitMessage,NULL
        return 0

    Endsw

    invoke DefWindowProcW,hWin,uMsg,wParam,lParam

    ret

WndProc endp

; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

TopXY proc wDim:DWORD, sDim:DWORD

    mov eax, [esp+8]
    sub eax, [esp+4]
    shr eax, 1

    ret 8

TopXY endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; 

ListBox proc a:DWORD,b:DWORD,wd:DWORD,ht:DWORD,hParent:DWORD,ID:DWORD

  ; --------------------------------
  ; the chr$() is LISTBOX in unicode.
  ; --------------------------------
    fn CreateWindowExW,WS_EX_LEFT,chr$(76,0,73,0,83,0,84,0,66,0,79,0,88,0),0, \
              WS_VSCROLL or WS_VISIBLE or WS_BORDER or WS_CHILD or \
              LBS_HASSTRINGS or LBS_NOINTEGRALHEIGHT or LBS_DISABLENOSCROLL, \
              a,b,wd,ht,hParent,ID,hInstance,NULL
    ret

ListBox endp

; 

end start
